# DescribeNatGatewayDetail

## 1. API Description

This API (DescribeNatGatewayDetail) is used to query the NAT rule details of a NAT gateway.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description     |
| -------------- | -------- | ------ | --------------- |
| natGatewayId   | Yes      | String | NAT gateway ID. |

## 3. Output Parameters

| Parameter Name | Type                                                                                                  | Description                                                                                                           |
| -------------- | ----------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                                | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| natGatewayId   | String                                                                                                | The unique ID of the NAT gateway.                                                                                     |
| name           | String                                                                                                | NAT gateway name.                                                                                                     |
| snats          | Array of [SnatEntry](https://docs.console.zenlayer.com/api-reference/compute/datastructure#snatentry) | SNAT rule list.                                                                                                       |
| dnats          | Array of [DnatEntry](https://docs.console.zenlayer.com/api-reference/compute/datastructure#dnatentry) | DNAT rule list.                                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query NAT rule details.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeNatGatewayDetail
<Common Request Params>

Request：
{
    "natGatewayId": "<natGatewayId>"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "natGatewayId": "<natGatewayId>",
    "name": "name",
    "snats": [
      {
        "snatEntryId": "<snatEntryId>",
        "eipIds": ["<eipId>"],
        "cidrs": ["0.0.0.0/0"],
        "eipIds": ["<eipId>"],
        "snatSubnets": null
      }
    ],
    "dnats": [
      {
        "dnatEntryId": "<dnatEntryId>",
        "status": "ACTIVE",
        "privateIp": "<privateIp>",
        "eipId": "<eipId>",
        "protocol": "TCP",
        "listenerPort": "1-30",
        "internalPort": "1-30"
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                          | Description                         |
| ---------------- | ----------------------------------- | ----------------------------------- |
| 404              | INVALID\_NAT\_NOT\_FOUND            | NAT gateway does not exist.         |
| 400              | UNSUPPORTED\_OPERATION\_NAT\_STATUS | NAT gateway state is not supported. |
